#! /usr/bin/env python
import sys,Numeric

## PARAMS

if len(sys.argv) <5:
    sys.stderr.write("""Usage:

    %s indel matrixF fa1 fa2

    str1 and str2 are strings, all caps, to align. mismatch
    and indel must be negative.

""" % (sys.argv[0],))
    sys.exit(-1)


ind=int(sys.argv[1])
matf=sys.argv[2]
f1=sys.argv[3]
f2=sys.argv[4]

if ind>0:
    sys.stderr.write("Error: indel must be negative.\n")
    sys.exit(-1)

#load strings

f=open(f1)
Str=f.readlines()
f.close()
vNm=Str[0][:-1]
v=Str[1][:-1]

f=open(f2)
Str=f.readlines()
f.close()
wNm=Str[0][:-1]
w=Str[1][:-1]

# load matrix
mat=Numeric.zeros([8,8])
f=open(matf,"r")
f.readline()
for i in xrange(8):
    ln=f.readline()[:-1].split()
    for j,Str in enumerate(ln[1:]):
        mat[i,j]=int(Str)
f.close()

# prepare dicts to give mat coords
coorD = {"A":0,"B":1,"C":2,"D":3,"E":4,"F":5,"G":6,"H":7}

n=len(v)+1 # length of strings+1 = dim of arrays
m=len(w)+1

scAr=Numeric.zeros((n,m)) # score array
btAr=Numeric.zeros((n,m),typecode='u') # backtracking array

## brAr values
STOP=0
UP=1
LEFT=2
UP_LEFT=3
# initialize first row and column of backtrack array
btAr[:,0]=STOP 
btAr[0,:]=STOP

# dp loops to calc score and backtrack arrays
for i in xrange(1,n):
    for j in xrange(1,m):
        scAr[i,j]=scAr[i-1,j-1]+mat[coorD[v[i-1]],coorD[w[j-1]]]
        if scAr[i,j]<=0:
            scAr[i,j]=0
            btAr[i,j]=STOP
        else:
            btAr[i,j]=UP_LEFT

        if (scAr[i,j-1]+ind)>scAr[i,j]:
            scAr[i,j]=scAr[i,j-1]+ind
            btAr[i,j]=LEFT
        if (scAr[i-1,j]+ind)>scAr[i,j]:
            scAr[i,j]=scAr[i-1,j]+ind
            btAr[i,j]=UP


# Find max score
mx=0
for i2 in range(n):
    for j2 in range(m):
        if scAr[i2,j2]>mx:
            mx=scAr[i2,j2]
            i=i2
            j=j2


# run through backtrack and get seq
vL=[]
wL=[]
while btAr[i,j]!=STOP:
    if btAr[i,j]==UP_LEFT:
        vL.append(v[i-1])
        wL.append(w[j-1])
        i=i-1;j=j-1
    elif btAr[i,j]==UP:
        vL.append(v[i-1])
        i=i-1
        wL.append("-")
    elif btAr[i,j]==LEFT:
        wL.append(w[j-1])
        j=j-1
        vL.append("-")

vL.reverse()
wL.reverse()
print vNm
print(''.join(vL))
print wNm
print(''.join(wL))
#print mx
#print scAr
#print btAr
